# Sewer.py

# Importion of modules
import pygame
import helpers
import random

# Initialize pygame.
pygame.init()


class Sewer( pygame.sprite.Sprite ):
	"""
	The Sewer class.
	"""

	# Static properties.
	image_ = None
	left_top_start_pos = [ 800, 70 ]
	# When to create a new sewer object and display it ?
	interval_creation_time = 250
	# The counter
	interval_creation_time_counter = 0
	scary_eyes_image = None

	
	def __init__( self ):
		"""
		"""
		pygame.sprite.Sprite.__init__( self )

		# Set up our sewer sprite.
		self.image = helpers.load_image( "sewer.png" )
		self.rect = self.image.get_rect( topleft = Sewer.left_top_start_pos )



	def update( self ):
		"""
		"""

		self.rect.move_ip( 3 * -1, 0 )

		if self.rect.right <= 0:
			self.kill()

	@staticmethod
	def create_new_sewer_object():
		"""
		This function if a new sewer object has to be created.

		It returns 'True' if that is the case; otherwise 'False'.
		"""

		if Sewer.interval_creation_time_counter >= Sewer.interval_creation_time:
			Sewer.reset_sewer_creation_time_counter()
			return True
		else:
			return False

	@staticmethod
	def increase_sewer_creation_time_counter():
		"""
		This function increases the sewer creation counter.  The counter defines when to create yet another Sewer object / sprite.
		"""

		Sewer.interval_creation_time_counter += 1

	@staticmethod
	def reset_sewer_creation_time_counter():
		"""
		This function resets the counter.  To 0.
		"""
		

		Sewer.interval_creation_time_counter = 0



class Red_Eyes( pygame.sprite.Sprite ):
	"""
	"""

	image_ = None
	

	def __init__( self, game_speed, sewer_rectangle ):
		"""
		"""
		pygame.sprite.Sprite.__init__( self )

		# Set up the sprite first.
		if Red_Eyes.image_ == None:
			Red_Eyes.image_ = helpers.load_image( "red_eye.png" )

		self.image = Red_Eyes.image_
		self.rect = self.image.get_rect()

		self.speed = game_speed

		# Randomly position it.
		left = sewer_rectangle[0]
		top = sewer_rectangle[1]
		right = sewer_rectangle[2]
		bottom = sewer_rectangle[3]
		
		self.rect.center = [ random.randint( left + 20, left + right - 20 ), random.randint( top + 20, top + bottom - 20 ) ]


	def update( self ):
		"""
		"""

		self.rect.move_ip( 3 * -1, 0 )

		if self.rect.right <= 0:
			self.kill()
		
		
