#
# One_Way_Trip.py
#

# Importion of modules.
import pygame


# Initialize pygame.
pygame.init()


class Timer( object ):
	"""
	Creates a very simple timer, that includes an update and reset function.
	The update() method returns 'True' is the timer has reached the specified 'fire_at' value.  Otherwise, it returns 'False'
	"""

	def __init__( self, increment_by, fire_at, start_time = 0 ):
		"""

		Parameters
			increment_by	Unsigned integer value
				Amount to add to 'self.timer' each time 'self.update()' is called.
			fire_at			Unsigned integer value
				An integer the defines when the timer should be reset and 'self.update()' should return 'True', rather than False.
			start_time		Unsigned Integer
				An integer defining the start value each time the timer is set and reset.
				OPTIONAL

		"""

		self.increment_by = increment_by
		self.fire_at = fire_at
		self.start_time = start_time

		self.timer = self.start_time


	def update( self ):
		"""
		This method updates the timer.  It returns 'True' if the 'self.fire_at' value has been reached or exceeded.
		Otherwise, 'False' is returned.
		"""

		self.update_timer()

		if self.timer >= self.fire_at:
			self.reset()
			return True
		else:
			return False


	def reset( self ):
		"""
		This method resets the timer.
		"""

		self.timer = self.start_time


	def update_timer( self ):
		"""
		This method updates the timer.
		"""

		self.timer += self.increment_by
